# rpmio/macro.c File Reference

`#include "system.h"`
`#include <stdarg.h>`
`#include <rpmio_internal.h>`
`#include <rpmlog.h>`
`#include <rpmmacro.h>`
`#include "debug.h"`

Include dependency graph for macro.c:

Go to the source code of this file.

## Data Structures
struct | MacroBuf_s
| Macro expansion state. More...
## Defines
#define | isblank(_c) ((char)(_c) == ' ' || (char)(_c) == '\t')
#define | iseol(_c) ((char)(_c) == '\n' || (char)(_c) == '\r')
#define | STREQ(_t, _f, _fn) ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))
#define | _MACRO_INTERNAL
#define | SAVECHAR(_mb, _c) { *(_mb)->t = (char) (_c), (_mb)->t++, (_mb)->nb--; }
#define | _MAX_MACRO_DEPTH 16
#define | _PRINT_MACRO_TRACE 0
#define | _PRINT_EXPAND_TRACE 0
#define | MACRO_CHUNK_SIZE 16
#define | SKIPBLANK(_s, _c)
#define | SKIPNONBLANK(_s, _c)
#define | COPYNAME(_ne, _s, _c)
#define | COPYOPTS(_oe, _s, _c)
#define | POPT_ERROR_NOARG -10
#define | POPT_ERROR_BADQUOTE -15
#define | POPT_ERROR_MALLOC -21
#define | POPT_ARGV_ARRAY_GROW_DELTA 5
#define | _suffix(_s, _x) (slen >= sizeof(_x) && !strcmp((_s)+slen-(sizeof(_x)-1), (_x)))
## Typedefs
typedef struct MacroBuf_s * | MacroBuf
| Macro expansion state.
## Functions
static int | expandMacro (MacroBuf mb)
| The main macro recursion loop.
static int | compareMacroName (const void *ap, const void *bp)
| Compare macro entries by name (qsort/bsearch).
static void | expandMacroTable (MacroContext mc)
| Enlarge macro table.
static void | sortMacroTable (MacroContext mc)
| Sort entries in macro table.
static char * | dupMacroEntry (MacroEntry me)
void | rpmDumpMacroTable (MacroContext mc, FILE *fp)
| Print macros to file stream.
int | rpmGetMacroEntries (MacroContext mc, miRE mire, int used, const char ***avp)
| Return macro entries as string array.
static MacroEntry * | findEntry (MacroContext mc, const char *name, size_t namelen)
| Find entry in macro table.
static char * | rdcl (char *buf, size_t size, FD_t fd)
| fgets(3) analogue that reads \ continuations.
static const char * | matchchar (const char *p, char pl, char pr)
| Return text between pl and matching pr characters.
static void | printMacro (MacroBuf mb, const char *s, const char *se)
| Pre-print macro expression to be expanded.
static void | printExpansion (MacroBuf mb, const char *t, const char *te)
| Post-print expanded macro expression.
static int | expandT (MacroBuf mb, const char *f, size_t flen)
| Save source and expand field into target.
static int | expandU (MacroBuf mb, char *u, size_t ulen)
| Save source/target and expand macro in u.
static int | doShellEscape (MacroBuf mb, const char *cmd, size_t clen)
| Expand output of shell command into target buffer.
static const char * | doDefine (MacroBuf mb, const char *se, int level, int expandbody)
| Parse (and execute) new macro definition.
static const char * | doUndefine (MacroContext mc, const char *se)
| Parse (and execute) macro undefinition.
static void | pushMacro (MacroEntry *mep, const char *n, const char *o, const char *b, int level)
| Push new macro definition onto macro entry stack.
static void | popMacro (MacroEntry *mep)
| Pop macro definition from macro entry stack.
static void | freeArgs (MacroBuf mb)
| Free parsed arguments for parameterized macro.
static const char * | grabArgs (MacroBuf mb, const MacroEntry me, const char *se, const char *lastc)
| Parse arguments (to next new line) for parameterized macro.
static void | doOutput (MacroBuf mb, int waserror, const char *msg, size_t msglen)
| Perform macro message output.
static void | doFoo (MacroBuf mb, int negate, const char *f, size_t fn, const char *g, size_t gn)
| Execute macro primitives.
static int | expandFIFO (MacroBuf mb, MacroEntry me, const char *g, size_t gn)
static int | XpoptDupArgv (int argc, const char **argv, int *argcPtr, const char ***argvPtr)
static int | XpoptParseArgvString (const char *s, int *argcPtr, const char ***argvPtr)
int | rpmGlob (const char *patterns, int *argcPtr, const char ***argvPtr)
| Return URL path(s) from a (URL prefixed) pattern glob.
int | expandMacros (void *spec, MacroContext mc, char *sbuf, size_t slen)
| Expand macro into buffer.
void | addMacro (MacroContext mc, const char *n, const char *o, const char *b, int level)
| Add macro to context.
void | delMacro (MacroContext mc, const char *n)
| Delete macro from context.
int | rpmDefineMacro (MacroContext mc, const char *macro, int level)
| Define macro in context.
int | rpmUndefineMacro (MacroContext mc, const char *macro)
| Undefine macro in context.
void | rpmLoadMacros (MacroContext mc, int level)
| Load macros from specific context into global context.
int | rpmLoadMacroFile (MacroContext mc, const char *fn)
| Load macro context from a macro file.
void | rpmInitMacros (MacroContext mc, const char *macrofiles)
| Initialize macro context from set of macrofile(s).
void | rpmFreeMacros (MacroContext mc)
| Destroy macro context.
int | isCompressed (const char *file, rpmCompressedMagic *compressed)
| Return type of compression used in file.
char * | rpmExpand (const char *arg,...)
| Return (malloc'ed) concatenated macro expansion(s).
int | rpmExpandNumeric (const char *arg)
| Return macro expansion as a numeric value.
char * | rpmCleanPath (char *path)
| Canonicalize file path.
const char * | rpmGetPath (const char *path,...)
| Return (malloc'ed) expanded, canonicalized, file path.
const char * | rpmGenPath (const char *urlroot, const char *urlmdir, const char *urlfile)
| Merge 3 args into path, any or all of which may be a url.
## Variables
const char * | rpmMacrofiles = MACROFILES
| List of macro files to read when configuring rpm.
static struct MacroContext_s | rpmGlobalMacroContext_s
MacroContext | rpmGlobalMacroContext = &rpmGlobalMacroContext_s
static struct MacroContext_s | rpmCLIMacroContext_s
MacroContext | rpmCLIMacroContext = &rpmCLIMacroContext_s
int | max_macro_depth = 16
int | print_macro_trace = 0
int | print_expand_trace = 0
static size_t | _macro_BUFSIZ = 16 * 1024
static int | _debug = 0

## Detailed Description

Definition in file macro.c.

## Define Documentation

#define _MACRO_INTERNAL

Definition at line 70 of file macro.c.

#define _MAX_MACRO_DEPTH 16

Definition at line 118 of file macro.c.

Referenced by rpmLoadMacroFile().

#define _PRINT_EXPAND_TRACE 0

Definition at line 126 of file macro.c.

#define _PRINT_MACRO_TRACE 0

Definition at line 122 of file macro.c.

#define _suffix | ( | _s,
|  | _x |  | ) | (slen >= sizeof(_x) && !strcmp((_s)+slen-(sizeof(_x)-1), (_x)))

#define COPYNAME | ( | _ne,
|  | _s,
|  | _c |  | ) |

Value:

    {       SKIPBLANK(_s,_c);       \
            while(((_c) = (int) *(_s)) && (xisalnum(_c) || (_c) == (int) '_')) \
                    *(_ne)++ = *(_s)++; \
            *(_ne) = '\0';          \
        }

Definition at line 541 of file macro.c.

Referenced by doDefine(), and doUndefine().

#define COPYOPTS | ( | _oe,
|  | _s,
|  | _c |  | ) |

Value:

    {   while(((_c) = (int) *(_s)) && (_c) != (int) ')') \
                    *(_oe)++ = *(_s)++; \
            *(_oe) = '\0';          \
        }

Definition at line 548 of file macro.c.

Referenced by doDefine().

#define isblank | ( | _c |  | ) | ((char)(_c) == ' ' || (char)(_c) == '\t')

Definition at line 9 of file macro.c.

Referenced by doDefine(), doFoo(), expandMacro(), and grabArgs().

#define iseol | ( | _c |  | ) | ((char)(_c) == '\n' || (char)(_c) == '\r')

Definition at line 11 of file macro.c.

Referenced by doDefine(), doShellEscape(), doUndefine(), expandMacro(), printExpansion(), printMacro(), and rdcl().

#define MACRO_CHUNK_SIZE 16

Definition at line 131 of file macro.c.

Referenced by expandMacroTable().

#define POPT_ARGV_ARRAY_GROW_DELTA 5

Definition at line 1821 of file macro.c.

Referenced by XpoptParseArgvString().

#define POPT_ERROR_BADQUOTE -15

error in paramter quoting

Definition at line 1818 of file macro.c.

Referenced by XpoptParseArgvString().

#define POPT_ERROR_MALLOC -21

memory allocation failed

Definition at line 1819 of file macro.c.

Referenced by XpoptDupArgv(), and XpoptParseArgvString().

#define POPT_ERROR_NOARG -10

missing argument

Definition at line 1817 of file macro.c.

Referenced by XpoptDupArgv().

#define SAVECHAR | ( | _mb,
|  | _c |  | ) | { *(_mb)->t = (char) (_c), (_mb)->t++, (_mb)->nb--; }

Definition at line 114 of file macro.c.

Referenced by doShellEscape(), and expandMacro().

#define SKIPBLANK | ( | _s,
|  | _c |  | ) |

Value:

    /*@-globs@*/    /* FIX: __ctype_b */ \
            while (((_c) = (int) *(_s)) && isblank(_c)) \
                    (_s)++;         \

Definition at line 529 of file macro.c.

Referenced by doDefine(), and rpmLoadMacroFile().

#define SKIPNONBLANK | ( | _s,
|  | _c |  | ) |

Value:

    /*@-globs@*/    /* FIX: __ctype_b */ \
            while (((_c) = (int) *(_s)) && !(isblank(_c) || iseol(_c))) \
                    (_s)++;         \

Definition at line 535 of file macro.c.

#define STREQ | ( | _t,
|  | _f,
|  | _fn |  | ) | ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))

Definition at line 13 of file macro.c.

Referenced by doFoo(), and expandMacro().

## Typedef Documentation

typedef struct MacroBuf_s * MacroBuf

Macro expansion state.

## Function Documentation

void addMacro | ( | MacroContext | mc,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level |
| ) |  |  |

Add macro to context.

Deprecated:
  Use rpmDefineMacro().

Parameters:

  | mc | macro context (NULL uses global context).
  | n | macro name
  | o | macro paramaters
  | b | macro body
  | level | macro recursion level (0 is entry API)

Definition at line 2107 of file macro.c.

References _, expandMacroTable(), findEntry(), pushMacro(), rpmGlobalMacroContext, rpmlog(), RPMLOG_ERR, and sortMacroTable().

Referenced by addMacroDefault(), addSource(), doDefine(), doSetupMacro(), expandMacro(), grabArgs(), handlePreambleTag(), headerMacrosLoad(), makeGPGSignature(), parseSpec(), rpmLoadMacros(), rpmPlatform(), rpmRebuildTargetVars(), rpmtsOpenSDB(), setDefaults(), and setPathDefault().

static int compareMacroName | ( | const void * | ap,
|  | const void * | bp |
| ) |  |  | `[static]`

Compare macro entries by name (qsort/bsearch).

Parameters:

  | ap | 1st macro entry
  | bp | 2nd macro entry

Returns:
  result of comparison

Definition at line 154 of file macro.c.

Referenced by findEntry(), and sortMacroTable().

void delMacro | ( | MacroContext | mc,
|  | const char * | n |
| ) |  |  |

Delete macro from context.

Parameters:

  | mc | macro context (NULL uses global context).
  | n | macro name

Definition at line 2146 of file macro.c.

References findEntry(), popMacro(), rpmGlobalMacroContext, and sortMacroTable().

Referenced by doUndefine(), handlePreambleTag(), headerMacrosUnload(), makeGPGSignature(), parseSpec(), rpmRebuildTargetVars(), and rpmtsOpenSDB().

static const char* doDefine | ( | MacroBuf | mb,
|  | const char * | se,
|  | int | level,
|  | int | expandbody |
| ) |  |  | `[static]`

Parse (and execute) new macro definition.

Parameters:

  | mb | macro expansion state
  | se | macro definition to parse
  | level | macro recursion level
  | expandbody | should body be expanded?

Returns:
  address to continue parsing

Definition at line 691 of file macro.c.

References _, _macro_BUFSIZ, addMacro(), alloca(), COPYNAME, COPYOPTS, expandU(), isblank, iseol, matchchar(), MacroBuf_s::mc, rpmlog(), RPMLOG_ERR, SKIPBLANK, and xisalpha().

Referenced by expandMacro(), and rpmDefineMacro().

static void doFoo | ( | MacroBuf | mb,
|  | int | negate,
|  | const char * | f,
|  | size_t | fn,
|  | const char * | g,
|  | size_t | gn |
| ) |  |  | `[static]`

Execute macro primitives.

Parameters:

  | mb | macro expansion state
  | negate | should logic be inverted?
  | f | beginning of field f
  | fn | length of field f
  | g | beginning of field g
  | gn | length of field g

Definition at line 1199 of file macro.c.

References _macro_BUFSIZ, alloca(), COMPRESSED_OTHER, expandT(), expandU(), getenv(), isblank, isCompressed(), PATH_MAX, realpath(), RPMLOG_INFO, RPMLOG_MASK, rpmlogSetMask(), stpcpy(), stpncpy(), STREQ, urlPath(), xisdigit(), and xisspace().

Referenced by expandMacro().

static void doOutput | ( | MacroBuf | mb,
|  | int | waserror,
|  | const char * | msg,
|  | size_t | msglen |
| ) |  |  | `[static]`

Perform macro message output.

Parameters:

  | mb | macro expansion state
  | waserror | use rpmError()?
  | msg | message to ouput
  | msglen | no. of bytes in message

Definition at line 1173 of file macro.c.

References _macro_BUFSIZ, alloca(), expandU(), rpmlog(), and RPMLOG_ERR.

Referenced by expandMacro().

static int doShellEscape | ( | MacroBuf | mb,
|  | const char * | cmd,
|  | size_t | clen |
| ) |  |  | `[static]`

Expand output of shell command into target buffer.

Parameters:

  | mb | macro expansion state
  | cmd | shell command
  | clen | no. bytes in shell command

Returns:
  result of expansion

Definition at line 652 of file macro.c.

References _macro_BUFSIZ, alloca(), expandU(), iseol, MacroBuf_s::nb, SAVECHAR, and MacroBuf_s::t.

Referenced by expandMacro().

static const char* doUndefine | ( | MacroContext | mc,
|  | const char * | se |
| ) |  |  | `[static]`

Parse (and execute) macro undefinition.

Parameters:

  | mc | macro context
  | se | macro name to undefine

Returns:
  address to continue parsing

Definition at line 826 of file macro.c.

References _, _macro_BUFSIZ, alloca(), COPYNAME, delMacro(), iseol, rpmlog(), RPMLOG_ERR, and xisalpha().

Referenced by expandMacro(), and rpmUndefineMacro().

static char* dupMacroEntry | ( | MacroEntry | me | ) | `[static]`

Definition at line 217 of file macro.c.

References stpcpy(), and xmalloc().

Referenced by rpmGetMacroEntries().

static int expandFIFO | ( | MacroBuf | mb,
|  | MacroEntry | me,
|  | const char * | g,
|  | size_t | gn |
| ) |  |  | `[static]`

Definition at line 1358 of file macro.c.

References expandT().

Referenced by expandMacro().

static int expandMacro | ( | MacroBuf | mb | ) | `[static]`

The main macro recursion loop.

Todo:
  Dynamically reallocate target buffer.

Parameters:

  | mb | macro expansion state

Returns:
  0 on success, 1 on failure

Definition at line 1381 of file macro.c.

References _, addMacro(), alloca(), MacroBuf_s::depth, doDefine(), doFoo(), doOutput(), doShellEscape(), doUndefine(), MacroBuf_s::expand_trace, expandFIFO(), expandT(), findEntry(), freeArgs(), grabArgs(), isblank, iseol, MacroBuf_s::macro_trace, matchchar(), max_macro_depth, MacroBuf_s::mc, MacroBuf_s::nb, print_expand_trace, print_macro_trace, printExpansion(), printMacro(), RMIL_GLOBAL, rpmDumpMacroTable(), rpmLoadMacroFile(), rpmlog(), RPMLOG_ERR, MacroBuf_s::s, SAVECHAR, STREQ, MacroBuf_s::t, xisalnum(), xisdigit(), and xmalloc().

Referenced by expandMacros(), expandT(), and expandU().

int expandMacros | ( | void * | spec,
|  | MacroContext | mc,
|  | char * | sbuf,
|  | size_t | slen |
| ) |  |  |

Expand macro into buffer.

Deprecated:
  Use rpmExpand().

Todo:
  Eliminate from API.

Parameters:

  | spec | cookie (unused)
  | mc | macro context (NULL uses global context).

Return values:

  | sbuf | input macro to expand, output expansion

Parameters:

  | slen | size of buffer

Returns:
  0 on success

Definition at line 2072 of file macro.c.

References _, alloca(), MacroBuf_s::depth, MacroBuf_s::expand_trace, expandMacro(), MacroBuf_s::macro_trace, MacroBuf_s::mc, MacroBuf_s::nb, print_expand_trace, print_macro_trace, rpmGlobalMacroContext, rpmlog(), RPMLOG_ERR, MacroBuf_s::s, MacroBuf_s::spec, and MacroBuf_s::t.

Referenced by addFileToTagAux(), copyNextLineFromOFI(), processPackageFiles(), rpmExpand(), and rpmGetPath().

static void expandMacroTable | ( | MacroContext | mc | ) | `[static]`

Enlarge macro table.

Parameters:

  | mc | macro context

Definition at line 174 of file macro.c.

References MACRO_CHUNK_SIZE, xmalloc(), and xrealloc().

Referenced by addMacro().

static int expandT | ( | MacroBuf | mb,
|  | const char * | f,
|  | size_t | flen |
| ) |  |  | `[static]`

Save source and expand field into target.

Parameters:

  | mb | macro expansion state
  | f | field
  | flen | no. bytes in field

Returns:
  result of expansion

Definition at line 562 of file macro.c.

References alloca(), expandMacro(), and MacroBuf_s::s.

Referenced by doFoo(), expandFIFO(), and expandMacro().

static int expandU | ( | MacroBuf | mb,
|  | char * | u,
|  | size_t | ulen |
| ) |  |  | `[static]`

Save source/target and expand macro in u.

Parameters:

  | mb | macro expansion state
  | u | input macro, output expansion
  | ulen | no. bytes in u buffer

Returns:
  result of expansion

Definition at line 615 of file macro.c.

References alloca(), expandMacro(), MacroBuf_s::nb, MacroBuf_s::s, and MacroBuf_s::t.

Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), and grabArgs().

static MacroEntry* findEntry | ( | MacroContext | mc,
|  | const char * | name,
|  | size_t | namelen |
| ) |  |  | `[static]`

Find entry in macro table.

Parameters:

  | mc | macro context
  | name | macro name
  | namelen | no. of bytes

Returns:
  address of slot in macro table with name (or NULL)

Definition at line 320 of file macro.c.

References alloca(), compareMacroName(), and rpmGlobalMacroContext.

static void freeArgs | ( | MacroBuf | mb | ) | `[static]`

Free parsed arguments for parameterized macro.

Parameters:

  | mb | macro expansion state

Definition at line 934 of file macro.c.

References _, MacroBuf_s::depth, MacroBuf_s::mc, popMacro(), rpmlog(), RPMLOG_ERR, and sortMacroTable().

Referenced by expandMacro().

static const char* grabArgs | ( | MacroBuf | mb,
|  | const MacroEntry | me,
|  | const char * | se,
|  | const char * | lastc |
| ) |  |  | `[static]`

Parse arguments (to next new line) for parameterized macro.

Todo:
  Use popt rather than getopt to parse args.

Parameters:

  | mb | macro expansion state
  | me | macro entry slot
  | se | arguments to parse
  | lastc | stop parsing at lastc

Returns:
  address to continue parsing

Definition at line 985 of file macro.c.

References _, _macro_BUFSIZ, addMacro(), alloca(), MacroBuf_s::depth, expandU(), getenv(), isblank, MacroBuf_s::mc, rpmlog(), RPMLOG_ERR, setenv(), stpcpy(), and unsetenv().

Referenced by expandMacro().

int isCompressed | ( | const char * | file,
|  | rpmCompressedMagic * | compressed |
| ) |  |  |

Return type of compression used in file.

Parameters:

  | file | name of file

Return values:

  | compressed | address of compression type

Returns:
  0 on success, 1 on I/O error

Definition at line 2370 of file macro.c.

References _, COMPRESSED_BZIP2, COMPRESSED_LZMA, COMPRESSED_LZOP, COMPRESSED_NOT, COMPRESSED_OTHER, COMPRESSED_ZIP, Fclose(), Ferror(), Fopen(), Fread(), Fstrerror(), rpmlog(), and RPMLOG_ERR.

Referenced by doFoo(), doPatch(), and doUntar().

static const char* matchchar | ( | const char * | p,
|  | char | pl,
|  | char | pr |
| ) |  |  | `[static]`

Return text between pl and matching pr characters.

Parameters:

  | p | start of text
  | pl | left char, i.e. '[', '(', '{', etc.
  | pr | right char, i.e. ']', ')', '}', etc.

Returns:
  address of last char before pr (or NULL)

Definition at line 422 of file macro.c.

Referenced by doDefine(), and expandMacro().

static void popMacro | ( | MacroEntry * | mep | ) | `[static]`

Pop macro definition from macro entry stack.

Parameters:

  | mep | address of macro entry slot

Definition at line 912 of file macro.c.

References _free().

Referenced by delMacro(), and freeArgs().

static void printExpansion | ( | MacroBuf | mb,
|  | const char * | t,
|  | const char * | te |
| ) |  |  | `[static]`

Post-print expanded macro expression.

Parameters:

  | mb | macro expansion state
  | t | current expansion string result
  | te | end of string

Definition at line 492 of file macro.c.

References _, MacroBuf_s::depth, and iseol.

Referenced by expandMacro().

static void printMacro | ( | MacroBuf | mb,
|  | const char * | s,
|  | const char * | se |
| ) |  |  | `[static]`

Pre-print macro expression to be expanded.

Parameters:

  | mb | macro expansion state
  | s | current expansion string
  | se | end of string

Definition at line 448 of file macro.c.

References _, MacroBuf_s::depth, and iseol.

Referenced by expandMacro().

static void pushMacro | ( | MacroEntry * | mep,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level |
| ) |  |  | `[static]`

Push new macro definition onto macro entry stack.

Parameters:

  | mep | address of macro entry slot
  | n | macro name
  | o | macro parameters (NULL if none)
  | b | macro body (NULL becomes "")
  | level | macro recursion level

Definition at line 879 of file macro.c.

References _free(), xmalloc(), and xstrdup().

Referenced by addMacro().

static char* rdcl | ( | char * | buf,
|  | size_t | size,
|  | FD_t | fd |
| ) |  |  | `[static]`

fgets(3) analogue that reads \ continuations.

Last newline always trimmed.

Parameters:

  | buf | input buffer
  | size | inbut buffer size (bytes)
  | fd | file handle

Returns:
  buffer, or NULL on end-of-file

Definition at line 358 of file macro.c.

References fdGetFILE, and iseol.

Referenced by rpmLoadMacroFile().

char* rpmCleanPath | ( | char * | path | ) |

Canonicalize file path.

Parameters:

  | path | path to canonicalize (in-place)

Returns:
  pointer to path

Definition at line 2495 of file macro.c.

Referenced by db3open(), doLookup(), relocateFileList(), rpmGetPath(), rpmioAccess(), and rpmQueryVerify().

int rpmDefineMacro | ( | MacroContext | mc,
|  | const char * | macro,
|  | int | level |
| ) |  |  |

Define macro in context.

Parameters:

  | mc | macro context (NULL uses global context).
  | macro | macro name, options, body
  | level | macro recursion level (0 is entry API)

Returns:

Todo:
  Document.

Definition at line 2162 of file macro.c.

References alloca(), doDefine(), MacroBuf_s::mc, and rpmGlobalMacroContext.

Referenced by main(), rpmcliAllArgCallback(), rpmdbRebuild(), and rpmLoadMacroFile().

void rpmDumpMacroTable | ( | MacroContext | mc,
|  | FILE * | fp |
| ) |  |  |

Print macros to file stream.

Parameters:

  | mc | macro context (NULL uses global context).
  | fp | file stream (NULL uses stderr).

Definition at line 244 of file macro.c.

References _, and rpmGlobalMacroContext.

Referenced by expandMacro(), and rpmShowRC().

char* rpmExpand | ( | const char * | arg,
|  |  | ... |
| ) |  |  |

Return (malloc'ed) concatenated macro expansion(s).

Parameters:

  | arg | macro(s) to expand (NULL terminates list)

Returns:
  macro expansion (malloc'ed)

Definition at line 2431 of file macro.c.

References _macro_BUFSIZ, expandMacros(), stpcpy(), xmalloc(), xrealloc(), and xstrdup().

Referenced by addChangelog(), archScore(), checkFiles(), checkForValidArchitectures(), cpio_doio(), dbiTagsInit(), defaultMachine(), doPrimary(), doSetupMacro(), fillOutMainPackage(), headerMacrosLoad(), headerMacrosUnload(), i18nTag(), ignoreDep(), initSourceHeader(), makeGPGSignature(), open_dso(), packageBinaries(), parseBuildInstallClean(), parseForRegexLang(), parseForSimple(), parseSpec(), prepFetch(), processSourceFiles(), rdToken(), readLine(), rpmCheckPassPhrase(), rpmcliAllArgCallback(), rpmcliImportPubkeys(), rpmcliQuery(), rpmdbNew(), rpmdbSetIteratorRE(), rpmdsCpuinfo(), rpmdsGetconf(), rpmdsLdconfig(), rpmdsPipe(), rpmdsSysinfo(), rpmExpandNumeric(), rpmfcClassify(), rpmfcExec(), rpmfcExpandAppend(), rpmfcGenerateDependsHelper(), rpmgiNext(), rpmgiOpen(), rpmInstallSourcePackage(), rpmnsParse(), rpmnsProbeSignature(), rpmPlatform(), rpmReadConfigFiles(), rpmReadRC(), rpmRollback(), rpmShowRC(), rpmts_IDTXglob(), rpmtsAddInstallElement(), rpmtsFindPubkey(), rpmtsRollback(), rpmtsSolve(), runInstScript(), runScript(), skipFiles(), spec_get_buildroot(), tagLoadATags(), unsatisfiedDepend(), urlFind(), urlGetFile(), and writeRPM().

int rpmExpandNumeric | ( | const char * | arg | ) |

Return macro expansion as a numeric value.

Boolean values ('Y' or 'y' returns 1, 'N' or 'n' returns 0) are permitted as well. An undefined macro returns 0.

Parameters:

  | arg | macro to expand

Returns:
  numeric value

Definition at line 2468 of file macro.c.

References _free(), and rpmExpand().

Referenced by checkFiles(), dbiOpen(), genCpioListAndHeader(), main(), newSpec(), parseScript(), parseSpec(), processPackageFiles(), relocateFileList(), rpmcliInstall(), rpmcliQuery(), rpmcliVerify(), rpmdbInit(), rpmdbNew(), rpmdbOpen(), rpmdbRebuild(), rpmdbVerify(), rpmdsELF(), rpmErase(), rpmfcGenerateDepends(), rpmRollback(), rpmts_Create(), rpmts_init(), rpmtsCreate(), rpmtsOpenSDB(), rpmtsRollback(), rpmtsRun(), skipFiles(), unsatisfiedDepend(), and urlGetFile().

void rpmFreeMacros | ( | MacroContext | mc | ) |

Destroy macro context.

Parameters:

  | mc | macro context (NULL uses global context).

Definition at line 2343 of file macro.c.

References _free(), and rpmGlobalMacroContext.

Referenced by rpmcliFini(), and rpmspecQuery().

const char* rpmGenPath | ( | const char * | urlroot,
|  | const char * | urlmdir,
|  | const char * | urlfile |
| ) |  |  |

Merge 3 args into path, any or all of which may be a url.

The leading part of the first URL encountered is used for the result, other URL prefixes are discarded, permitting a primitive form of URL inheiritance.

Parameters:

  | urlroot | root URL (often path to chroot, or NULL)
  | urlmdir | directory URL (often a directory, or NULL)
  | urlfile | file URL (often a file, or NULL)

Returns:
  expanded, merged, canonicalized path (malloc'ed)

Definition at line 2618 of file macro.c.

References _free(), alloca(), file, rpmGetPath(), URL_IS_DASH, and urlPath().

Referenced by addSource(), db3close(), db3open(), db_init(), doIcon(), doPatch(), doRmSource(), doSetupMacro(), doUntar(), handlePreambleTag(), prepFetch(), processBinaryFile(), processMetadataFile(), processPackageFiles(), rpmdsNew(), rpmfcGenerateDepends(), rpmfiNew(), rpmInstallSourcePackage(), rpmpsmStage(), rpmTempFile(), sql_close(), sql_initDB(), and sql_open().

int rpmGetMacroEntries | ( | MacroContext | mc,
|  | miRE | mire,
|  | int | used,
|  | const char *** | avp |
| ) |  |  |

Return macro entries as string array.

Parameters:

  | mc | macro context (NULL uses global context)
  | mire | pattern to match (NULL disables)
  | used | macro usage (<0 all, =0 unused, >=1 used count)

Return values:

  | *avp | macro definitions

Returns:
  no. of entries

Definition at line 277 of file macro.c.

References dupMacroEntry(), rpmGlobalMacroContext, xcalloc(), and xrealloc().

Referenced by packageSources(), and rpmtsFree().

const char* rpmGetPath | ( | const char * | path,
|  |  | ... |
| ) |  |  |

Return (malloc'ed) expanded, canonicalized, file path.

Parameters:

  | path | macro(s) to expand (NULL terminates list)

Returns:
  canonicalized path (malloc'ed)

Definition at line 2586 of file macro.c.

References _macro_BUFSIZ, alloca(), expandMacros(), rpmCleanPath(), stpcpy(), and xstrdup().

Referenced by addFileToTagAux(), buildSpec(), checkSpec(), Chroot(), db3close(), db3open(), doPatch(), doUntar(), genCpioListAndHeader(), initSourceHeader(), lzdWriteOpen(), packageBinaries(), packageSources(), parseFiles(), parseForSimple(), parseSpec(), processPackageFiles(), rpmcliInstall(), rpmdbExportInfo(), rpmdbMoveDatabase(), rpmdbRebuild(), rpmdbRemoveDatabase(), rpmdbURIPath(), rpmdsSysinfo(), rpmfiBuildREContexts(), rpmfiNew(), rpmGenPath(), rpmGetFilesystemUsage(), rpmpsmStage(), rpmQueryVerify(), rpmsxParse(), rpmts_Run(), rpmtsCreate(), rpmtsOpenDB(), rpmtsOpenSDB(), and unsatisfiedDepend().

int rpmGlob | ( | const char * | patterns,
|  | int * | argcPtr,
|  | const char *** | argvPtr |
| ) |  |  |

Return URL path(s) from a (URL prefixed) pattern glob.

Parameters:

  | patterns | glob pattern

Return values:

  | *argcPtr | no. of paths
  | *argvPtr | array of paths (malloc'd contiguous blob)

Returns:
  0 on success

Definition at line 1934 of file macro.c.

References _free(), Glob(), Glob_error(), Glob_pattern_p(), Globfree(), setlocale, URL_IS_DASH, URL_IS_FTP, URL_IS_HKP, URL_IS_HTTP, URL_IS_HTTPS, URL_IS_PATH, URL_IS_UNKNOWN, urlPath(), xmalloc(), XpoptParseArgvString(), xrealloc(), and xstrdup().

Referenced by IDTXglob(), processBinaryFile(), rpmcliInit(), rpmgiGlobArgv(), rpmInitMacros(), and rpmReadPackageManifest().

void rpmInitMacros | ( | MacroContext | mc,
|  | const char * | macrofiles |
| ) |  |  |

Initialize macro context from set of macrofile(s).

Parameters:

  | mc | macro context
  | macrofiles | colon separated list of macro files (NULL does nothing)

Definition at line 2262 of file macro.c.

References _free(), _suffix, RMIL_CMDLINE, rpmCLIMacroContext, rpmGlob(), rpmGlobalMacroContext, rpmLoadMacroFile(), rpmLoadMacros(), rpmlog(), RPMLOG_WARNING, rpmSecuritySaneFile(), xmalloc(), and xstrdup().

Referenced by rpmReadRC().

int rpmLoadMacroFile | ( | MacroContext | mc,
|  | const char * | fn |
| ) |  |  |

Load macro context from a macro file.

Parameters:

  | mc | (unused)
  | fn | macro file name

Definition at line 2224 of file macro.c.

References _macro_BUFSIZ, _MAX_MACRO_DEPTH, alloca(), Fclose(), Ferror(), Fopen(), max_macro_depth, rdcl(), RMIL_MACROFILES, rpmDefineMacro(), and SKIPBLANK.

Referenced by expandMacro(), and rpmInitMacros().

void rpmLoadMacros | ( | MacroContext | mc,
|  | int | level |
| ) |  |  |

Load macros from specific context into global context.

Parameters:

  | mc | macro context (NULL does nothing).
  | level | macro recursion level (0 is entry API)

Definition at line 2184 of file macro.c.

References addMacro(), and rpmGlobalMacroContext.

Referenced by rpmInitMacros().

int rpmUndefineMacro | ( | MacroContext | mc,
|  | const char * | macro |
| ) |  |  |

Undefine macro in context.

Parameters:

  | mc | macro context (NULL uses global context).
  | macro | macro name

Returns:

Todo:
  Document.

Definition at line 2176 of file macro.c.

References doUndefine(), and rpmGlobalMacroContext.

Referenced by rpmcliAllArgCallback().

static void sortMacroTable | ( | MacroContext | mc | ) | `[static]`

Sort entries in macro table.

Parameters:

  | mc | macro context

Definition at line 196 of file macro.c.

References compareMacroName().

Referenced by addMacro(), delMacro(), and freeArgs().

static int XpoptDupArgv | ( | int | argc,
|  | const char ** | argv,
|  | int * | argcPtr,
|  | const char *** | argvPtr |
| ) |  |  | `[static]`

< missing argument

< missing argument

< memory allocation failed

Definition at line 1823 of file macro.c.

References POPT_ERROR_MALLOC, and POPT_ERROR_NOARG.

Referenced by XpoptParseArgvString().

static int XpoptParseArgvString | ( | const char * | s,
|  | int * | argcPtr,
|  | const char *** | argvPtr |
| ) |  |  | `[static]`

< memory allocation failed

< error in paramter quoting

< error in paramter quoting

Definition at line 1863 of file macro.c.

References alloca(), POPT_ARGV_ARRAY_GROW_DELTA, POPT_ERROR_BADQUOTE, POPT_ERROR_MALLOC, and XpoptDupArgv().

Referenced by rpmGlob().

## Variable Documentation

int _debug = 0`[static]`

Definition at line 1932 of file macro.c.

size_t _macro_BUFSIZ = 16 * 1024`[static]`

Definition at line 134 of file macro.c.

Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), doUndefine(), grabArgs(), rpmExpand(), rpmGetPath(), and rpmLoadMacroFile().

int max_macro_depth = 16

Definition at line 120 of file macro.c.

Referenced by expandMacro(), and rpmLoadMacroFile().

int print_expand_trace = 0

Definition at line 128 of file macro.c.

Referenced by expandMacro(), and expandMacros().

int print_macro_trace = 0

Definition at line 124 of file macro.c.

Referenced by expandMacro(), and expandMacros().

MacroContext rpmCLIMacroContext = &rpmCLIMacroContext_s

Definition at line 93 of file macro.c.

Referenced by rpmcliAllArgCallback(), rpmcliFini(), and rpmInitMacros().

struct MacroContext_s rpmCLIMacroContext_s`[static]`

Definition at line 91 of file macro.c.

MacroContext rpmGlobalMacroContext = &rpmGlobalMacroContext_s

Definition at line 88 of file macro.c.

Referenced by addMacro(), delMacro(), expandMacros(), findEntry(), newSpec(), rpmDefineMacro(), rpmDumpMacroTable(), rpmFreeMacros(), rpmGetMacroEntries(), rpmInitMacros(), rpmLoadMacros(), and rpmUndefineMacro().

struct MacroContext_s rpmGlobalMacroContext_s`[static]`

Definition at line 86 of file macro.c.